#!/usr/local/bin/perl
#### ե빽ۥץ libgns.pl V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ
#### 2004/11/23 V3.10 ֻʸޤޤȤRSS顼Ȥʤ
#### 2004/11/02 V3.02 RSScontent:encodedǤޤ褦ˤ
####                  descriptionʤcontent:encodedǤ裲ʹߤޤ褦ˤ
#### 2004/07/26 V3.01 config.phΥ󥯥롼ɤǽ˹Ԥ褦ˤ
#### 2004/07/24 V3.01 RSSrdf:aboutǤURLRSSեؤ褦˽
####                  RSSdescriptionǤ$DIARY_DESCRIPTIONФƤʤ
#### 2004/07/22 V3.01 @timeޥɤ24ʹߤꤷν
#### 2004/07/21 V3.01 ƥΥڡʸڤΤƤ
####                  ԤƤ
#### 2004/07/21 V3.01 config.phư
#### 2004/05/14 V3.00 С󳫻ϡ

require "config.ph";

$GENERATOR = "GNS/4.00";

$DIGESTHEADERNAME = "10.html";
$DIGESTPREMEMONAME = "11.html";
$DIGESTPOSTMEMONAME = "20.html";
$DIGESTFOOTERNAME = "21.html";
$BASEHEADERNAME = "30.html";
$BASEFOOTERNAME = "40.html";
$INDEXHEADERNAME = "50.html";
$INDEXFOOTERNAME = "51.html";
$CAINDEXHEADERNAME = "52.html";
$CAINDEXFOOTERNAME = "53.html";
$TRACKBACKHEADERNAME = "60.html";
$TRACKBACKFOOTERNAME = "61.html";
$UPDATEPINGLISTNAME = "96.html";
$PARAMREPLACENAME = "97.html";
$ITEMNAME = "98.html";
$REPLACENAME = "99.html";

$SYSTEMPARAMREPLACENAME = "sysmacro.html";
$SYSTEMREPLACENAME = "sysuri.html";

$GNS_LOCKFILE = "$TMPDIR/%%lock";

########################################################################
###  
#
sub Setup {
	local( $cwd );
	local( $umaskback );

	$cwd = chop($cwd = `pwd`);
	if ( !(-e "libgns.pl") ) {
		die "execute in this ($cwd) folder.";
	}
	$umaskback = umask( oct($DIARY_TMPDIR_PERM) ^ 0777 );
	mkdir( "tmp", oct($DIARY_TMPDIR_PERM) ) if ( !(-e "tmp") );
	umask( $umaskback );

	$ENCODECACHENAME = "enccache.txt";
	$MAXENCODECACHEENTRY = 256;
	&ReadENCODECACHE();
	&Setup_KEEPDIR();
	&Setup_PARTS();
	&Setup_ITEMS();

	&MakeParamReplaceDatabase( $SYSTEMPARAMREPLACENAME );
	&MakeParamReplaceDatabase( $KEEPDIR . $SLASH . $PARAMREPLACENAME );
	&MakeReplaceDatabase( $SYSTEMREPLACENAME );
	&MakeReplaceDatabase( $KEEPDIR . $SLASH . $REPLACENAME );

	$SIG{'__DIE__'} = $SIG{'TRAP'} = $SIG{'ABRT'} = $SIG{'STOP'} = $SIG{'TERM'} = $SIG{'INT'} = $SIG{'KILL'} = $SIG{'QUIT'} = $SIG{'HUP'} = $SIG{'PIPE'} = \&Finish;
	&CreateSemaphore();
	return;
}

########################################################################
### λ 
#
sub Finish {
	&FlushENCODECACHE();
	rmdir($GNS_LOCKFILE);
	return;
}

########################################################################
### ޥե
#
sub CreateSemaphore {
	local( $abort_counter ) = 60;
	local( $not_aborted ) = 1;
	local( $umaskback );

	$umaskback = umask( oct($DIARY_TMPDIR_PERM) ^ 0777 );
	while(!mkdir($GNS_LOCKFILE, oct($DIARY_TMPDIR_PERM))) {
		$abort_counter--;
		if ( $abort_counter eq 0 ) {
			$not_aborted = 0;
			last;
		}
		sleep(1);
	}
	umask( $umaskback );

	if ( $not_aborted == 0 ) {
#		&doterm();
		print "Content-Type: text/plain\n\n";
		print "Cannot create semaphore.  Please contact diary owner.\n";
		die "Cannot create semaphore [$GNS_LOCKFILE].";
	}

	return (0);
}

########################################################################
### ȥեɽ 
#
sub SPrintCommentForm {
	local( $year, $month, $day, $ntitle ) = @_;
	local( $s );

	$s = sprintf( 
	  "<SPAN class=\"cmform\"><FORM action=\"%s%s/%04d%02d%02d%02d/\" method=\"POST\">" .
	  "Name:<INPUT TYPE=\"text\" NAME=\"GNSname\" SIZE=\"8\"> " .
	  "Comment:<INPUT TYPE=\"text\" NAME=\"GNScomment\" SIZE=\"32\"> " .
	  "<INPUT TYPE=\"submit\" NAME=\"command\" VALUE=\"Send\">" .
	  "</FORM></SPAN>" .
	  "",
	  $TRACKBACKBASEURL, $COMMENTCGI,
	  $year, $month, $day, $ntitle
	);
	$s = &SPrintCommentForm_Config2( $s, $year, $month, $day, $ntitle );
	if ( $RENDERTEST ) {
		$s =~ s:<FORM[^>]*>::;
		$s =~ s:</FORM[^>]*>::;
	}

	return ( $s );
}

########################################################################
### ȥåХåURLɽ 
#
sub SPrintTrackbackURL {
	local( $year, $month, $day, $part, $ntitle ) = @_;
	local( $s );

	$s = sprintf(
	  "<SPAN class=\"trackback\">" .
	  "<A HREF=\"%s%s/%04d%02d%02d%02d/\" TITLE=\"Copy Trackback URL\">[Trackback]</A>" .
	  "</SPAN>" .
	  "",
	  $TRACKBACKBASEURL, $TRACKBACKCGI, $year, $month, $day, $ntitle,
	);

	return ( &SPrintTrackbackURL_Config2( $s, $year, $month, $day, $ntitle ) );
}

########################################################################
### /ȥåХå󥯤ɽ 
#
sub SPrintViewTBCMGuide {
	local( $year, $month, $day, $part, $ntitle ) = @_;
	local( $s );
	local( $tbcm ) = "";
	local( $logcount ) = "";

	$tbcm = "Trackback" if ($FLAG_TRACKBACK);
	$tbcm = "Comment" if ($FLAG_COMMENT);
	$tbcm = "Trackback/Comment" if ($FLAG_TRACKBACK&&$FLAG_COMMENT);

	if ( $VIEWTRACKBACKCOUNTCGI ) {
		$logcount = sprintf( "<!--#include virtual=\"%s?date=%04d%02d%02d%02d\"-->" ,
		  $TRACKBACKCOUNTCGI, $year, $month, $day, $ntitle
		);
	}

	$s = sprintf(
	  "<SPAN class=\"tbcmguide\">" .
	  "<A HREF=\"%s%04d%02dt.html#$ANCHOR%02d%02d\" TITLE=\"View %s Log\">[View Log%s]</A>" .
	  "</SPAN>" .
	  "",
	  $TRACKBACKBASEURL, $year, $month, $day, $ntitle, $tbcm,
	  $logcount
	);

	return ( &SPrintViewTBCMGuide_Config2( $s, $year, $month, $day, $ntitle ) );
}

########################################################################
### ǽζڤɽ 
#
sub PrintStart {
	local( $FOUT ) = @_;

	print $FOUT "<!-- ====================================================================================== -->\n";
	print $FOUT "\n";
}

########################################################################
### եɽ 
#
sub PrintDiaryDate {
	local( $FOUT, $year, $month, $day, $wday, $part ) = @_;
	local( $s );
	local( $tbmode ) = ( $FLAG_TRACKBACK ? 1 : 0 );  # ߤեˤTBʤ
# printf( "[wday: $wday]\n" );

	$s = sprintf(
	  "<A NAME=\"$ANCHOR%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d\">" .
	  "<SPAN class=\"yymmdd\">%04d/%02d/%02d</SPAN></A> " .
	  "<SPAN class=\"dayweek\">(%s)</SPAN> " .
	  "<SPAN class=\"dayweather\">%s</SPAN> " .
	  "<SPAN class=\"daytopic\">%s</SPAN>" .
	  "",
	  $day, $year, $month, $PARTS[$part], $day, $year, $month, $day,
	  $WDAYS[$wday], $PARAM_WEATHER, $PARAM_TOPIC
	);

	$s = &SPrintDiaryDate_Config2( $s, $year, $month, $day, $wday, $part, $PARAM_WEATHER, $PARAM_TOPIC, $PARAM_CATEGORY, $PARAM_TIME, $tbmode );
	$s =~ s/[ ]+$//;
	print $FOUT "<DIV class=\"daybox\">\n";
	print $FOUT "<DIV class=\"datebox\"><H3 class=\"date\">$s</H3></DIV>\n";
}

########################################################################
### ȥ륿ɽ 
#
sub SPrintDiaryTitle {
	local( $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time ) = @_;
	local( $s, $s1, $s2 );
	local( $catprint );
	local( $href );
	local( $tbping );
	local( $tbmode ) = ( $FLAG_TRACKBACK ? 1 : 0 );

	$href= sprintf( "%04d%02d%s.html#$ANCHOR%02d%02d",
	  $year, $month, $PARTS[$part], $day, $ntitle
	);

	if ( $tbmode ) {
		$tbping = sprintf( "%s%s/%04d%02d%02d%02d/",
		  $TRACKBACKBASEURL, $TRACKBACKCGI, $year, $month, $day, $ntitle,
		);

		$s1 = "  xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n" .
		      "  xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n" .
		      "  xmlns:trackback=\"http://madskills.com/public/xml/rss/module/trackback/\"\n" .
		      "  xml:lang=\"ja\">" .
		      "";
		$s1 = &SPrintContentRSSHeader_Config2( $s1 );
		$s = $title;
		while ( $s =~ s:<[^<>]*>: :g ) {}
		$s =~ s:\&[^;]*;::g;
		$s =~ s:\&::g;
		$s =~ s:[ ]+: :g;
		$s =~ s:\n::g;
		$s1 = "<!--\n<rdf:RDF \n$s1\n" .
		      "<rdf:Description\n" .
		      "  rdf:about=\"$URLBASENAME$href\"\n" .
		      "  dc:identifier=\"$URLBASENAME$href\"\n" .
		      "  trackback:ping=\"$tbping\"\n" .
		      "  dc:title=\"$s\" />\n" .
		      "</rdf:RDF>\n".
		      "-->\n".
		      "";
	}

	if ( $category eq '' ) {
		$s2 = sprintf(
		  "<DIV class=\"titlebox\"><H4 class=\"title\">" .
		  "<A NAME=\"$ANCHOR%02d%02d\" HREF=\"$href\">" .
		  "<SPAN class=\"titlemark\">%s</SPAN>" .
		  "<SPAN class=\"titlestr\">%s</SPAN>" .
		  "</A></H4>\n" .
		  "<DL class=\"dl\"><DD class=\"dd\">".
		  "",
		  $day, $ntitle, $TITLEMARK, $title
		);
	} else {
		$catprint = &MakeCategoryLinkStrings( $year, $category );
		$s2 = sprintf(
		  "<DIV class=\"titlebox\"><H4 class=\"title\">" .
		  "<A NAME=\"$ANCHOR%02d%02d\" HREF=\"$href\">" .
		  "<SPAN class=\"titlemark\">%s</SPAN>" .
		  "<SPAN class=\"titlestr\">%s</SPAN>" .
		  "</A>" .
		  "<SPAN class=\"category\"> (%s)</SPAN>" .
		  "</H4>" .
		  "<DL class=\"dl\"><DD class=\"dd\">".
		  "",
		  $day, $ntitle, $TITLEMARK, $title, $catprint
		);
	}

	$s = $s1 . $s2;

	$s = &SPrintDiaryTitle_Config2( $s, $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time, $tbmode );

	return ( $s );
}

########################################################################
### ȥåХåե뤬ʤк 
#
sub MakeTBCMView {
	local( $year, $month, $day, $ntitle ) = @_;
	local( $logfilename );

	$s = "<BR clear=\"all\" class=\"clearall\">\n";

	if ($FLAG_TRACKBACK || $FLAG_COMMENT) {
		if ($FLAG_TBCMVIEW) {
			$logfilename = sprintf(
			  "${PUTDIR}${SLASH}%04d%02dt.html",
			  $year, $month
			);
			if ( !(-e $logfilename) ) {
				&BindTrackbackView( $year, $month, $day, $ntitle );
				&BindTrackbackViewLatest();
			}
		}
	}
}

########################################################################
### ȥζڤɽ 
#
sub SPrintDiaryTitleClose {
	local( $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time ) = @_;
	local( $gutext ) = "";
	local( $cmtext ) = "";
	local( $tbtext ) = "";
	local( $s );
	local( $tbmode ) = 2;
	local( $logfilename );

	$s = "<BR clear=\"all\" class=\"clearall\">\n";

	if ($FLAG_TRACKBACK || $FLAG_COMMENT) {
		$s .= 
		  "<DIV align=\"right\" class=\"tbcm\"><SMALL><TABLE>\n".
		  "<TR><TD>";
		if ($FLAG_TBCMVIEW) {
			$logfilename = sprintf(
			  "${PUTDIR}${SLASH}%04d%02dt.html",
			  $year, $month
			);
			$gutext = &SPrintViewTBCMGuide( $year, $month, $day, $part, $ntitle );
			$s .= "$gutext</TD>\n<TD>";
		}
		if ($FLAG_TRACKBACK) {
			$tbtext = &SPrintTrackbackURL( $year, $month, $day, $part, $ntitle );
			$s .= "$tbtext</TD>\n<TD>";
		}
		if ($FLAG_COMMENT) {
			$cmtext = &SPrintCommentForm( $year, $month, $day, $ntitle );
			$s .= "</TD>\n<TD>$cmtext";
		}
		$s .= "</TD></TR>";
		$s .= "</TABLE></SMALL></DIV>\n";
	}
	$s .= 
	  "</DD></DL>\n".
	  "</DIV><!-- titlebox -->\n";

	return ( &SPrintDiaryTitleClose_Config2( $s, $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time ) );
}

########################################################################
### ζڤɽ 
#
sub PrintInterval {
	local( $FOUT ) = @_;
	local( $s );

	$s = <<EOF;

<!-- ====================================================================================== -->
<HR SIZE=\"1\" WIDTH=\"50%\" ALIGN=\"center\" class=\"day_separator\">

EOF
	$s = &SPrintInterval_Config2( $s ) if ( defined(SPrintInterval_Config2) );

	print $FOUT $s;
}

########################################################################
### Ǹζڤɽ 
#
sub PrintTerminate {
	local( $FOUT ) = @_;
	local( $s );

	$s = <<EOF;
<!-- ====================================================================================== -->

EOF
	$s = &SPrintTerminate_Config2( $s ) if ( defined(&SPrintTerminate_Config2) );

	print $FOUT $s;
}

########################################################################
### ʬʸɽ 
#
sub PrintDiary {
	local( $FOUT, $year, $month, $day, $part, $istoday ) = @_;
	local( $wday, $i, $s );

# print "PrintDiary $year, $month, $day, $part, $istoday\n";
	&YMD2DAYS( $year, $month, $day );
	$wday = $WDAY;
	&GetDiary( $year, $month, $day, $wday, $part, $istoday );
	if ( $istoday == 1 ) {
		$s = "<!-- PiloWeb_Begin -->\n";
		$s = &SPrintTodayDiaryHeader_Config2( $s ) if ( defined(&SPrintTodayDiaryHeader_Config2) );
		print $FOUT $s;
	}
	&PrintDiaryDate( $FOUT, $year, $month, $day, $wday, $part );
	$FOOTNOTE_REFER = 0;
	for ( $i=0; $i<$DIARYLINES; $i++ ) {
		$s = &Replace( $DIARYLINE[$i], $year, $month, $part, $day );
		print $FOUT "$s\n";
	}
	if ( $NTITLE ) {
		print $FOUT &SPrintDiaryTitleClose( $year, $month, $day, $wday, $part, $NTITLE, $PARAM_TITLE, $PARAM_CATEGORY, $PARAM_TIME );
	}

	if ( $PARAM_FOOT ) {
		print $FOUT "<P>$FOOTSTARTMARK$PARAM_FOOT$FOOTENDMARK</P>\n";
	}
	if ( $istoday == 1 ) {
		$s = "<!-- PiloWeb_End -->\n";
		$s = &SPrintTodayDiaryFooter_Config2( $s ) if ( defined(&SPrintTodayDiaryFooter_Config2) );
		print $FOUT $s;
	}
	print $FOUT "</DIV><!-- daybox -->\n";
}

########################################################################
### Ĥ 
#
sub CloseSection {
	local( $sectionmode ) = @_;
	local( $line );

	if ( $DIARYLINES <= 0 ) {
		return;
	}

	$line = $DIARYLINE[$DIARYLINES-1];
	if ( $sectionmode == 0 ) {
		$line .= '</P>';
		$RSS_DESCRIPTION[$RSS_N] .= "</P>";
	} elsif ( $sectionmode == 1 ) {
		$DIARYLINE[$DIARYLINES++] = '';
		$line = '</CODE></PRE></BLOCKQUOTE>';
		$RSS_DESCRIPTION[$RSS_N] .= "</CODE></PRE></BLOCKQUOTE>";
	} elsif ( $sectionmode == 2 ) {
		$DIARYLINE[$DIARYLINES++] = '';
		$line = '</PRE></BLOCKQUOTE>';
		$RSS_DESCRIPTION[$RSS_N] .= '</PRE></BLOCKQUOTE>';
	} elsif ( $sectionmode == 3 ) {
		$DIARYLINE[$DIARYLINES++] = '';
		$line = '</B></BIG></DIV>';
		$RSS_DESCRIPTION[$RSS_N] .= '</B></BIG></DIV>';
	} elsif ( $sectionmode == 4 ) {
		$DIARYLINE[$DIARYLINES++] = '';
		$line = '</UL>';
		$RSS_DESCRIPTION[$RSS_N] .= '</UL>';
	} elsif ( $sectionmode == 5 ) {
		$DIARYLINE[$DIARYLINES++] = '';
		$line = '</OL>';
		$RSS_DESCRIPTION[$RSS_N] .= '</OL>';
	} elsif ( $sectionmode == 6 ) {
		$line .= '</SMALL></P></DL>';
		$RSS_DESCRIPTION[$RSS_N] .= '</SMALL></P></DL>';
	}
	$DIARYLINE[$DIARYLINES-1] = $line;
}

########################################################################
### ޥե֤̾ 
#
sub MakeMasterFileName {
	local( $year, $month, $day ) = @_;
	local( $s );

	$s = sprintf( "${GETDIR}${SLASH}%04d${SLASH}%02d%02d.html", $year+0, $month+0, $day+0 );
	return ($s);
}

########################################################################
### epochYYYY/MM/DD hh:mm:ssѴ 
#
sub MakeTimeStr {
	local( $epoch ) = @_;
	local( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst );
	local( $s );

	( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime( $epoch );
	$s = sprintf( "%04d/%02d/%02d %02d:%02d:%02d", 
	  $year+1900, $mon+1, $mday, $hour, $min, $sec
	);

	return ($s);
}

########################################################################
### ʬΥޥե 
##  ƱִȤԤʤ 
#
sub GetDiary {
	local( $year, $month, $day, $wday, $part, $istoday ) = @_;
	local( $cmd, $line, $sectionmode, $nsection, $fin, $sections, $categorystr, $s );
	local( $macroname, $macrovalue, @sp );
	local( $time_h, $time_m, $time_s, $time_daycarryup );
	local( $nsection2 );
	local( $FIN );

	$PARAM_WEATHER = '';
	$PARAM_TOPIC = '';
	$PARAM_FOOT = '';
	$PARAM_TITLE = '';
	$PARAM_CATEGORY = '';
	$DIARYLINES = 0;
	$NTITLE = 0;

	$fin = &MakeMasterFileName( $year, $month, $day );
	return if ( !(-e $fin) );

	$titleflag = 0;
	$sectionmode = -1;
	$nsection = 0;
	$nsection2 = 0;
	$nfootnote = 0;
	$sections = 'abcdefghijklmnopqrstuvwxyz';
	$PARAM_TIME = &MakeTimeStr( (stat($fin))[9] );
	$PARAM_TIME_FILE = $PARAM_TIME;

	$RSS_N++;
	$RSS_YEAR[$RSS_N] = $year;
	$RSS_MONTH[$RSS_N] = $month;
	$RSS_PART[$RSS_N] = $part;
	$RSS_DATE[$RSS_N] = $day;
	$RSS_TITLE[$RSS_N] = sprintf( "%02d/%02d/%02d", $year, $month, $day );
	$RSS_NTITLE[$RSS_N] = 0;
	$RSS_DESCRIPTION[$RSS_N] = '';
	$RSS_SUBJECT[$RSS_N] = '';
	$RSS_LINKURL[$RSS_N] = sprintf( "%04d%02d%s.html#$ANCHOR%02d", $year, $month, $PARTS[$part], $day );
	$RSS_TIME[$RSS_N] = $PARAM_TIME;

# printf( "GetDiary %d %d %d\n", $year, $month, $day );
	$cmd = $NKFCMD . ' -e ' . $fin . "|";
	$FIN = $cmd; open( FIN );
	while ( $line = <FIN> ) {
		$line =~ s/[\012\015]+//;
		if ( length($line) <= 0 ) {
			if ($sectionmode == 1) {
				;
			} elsif ($sectionmode == 2) {
				;
			} else {
				next;
			}
		} elsif ( $line =~ s/^\@weather[ \t]+// ) {
			$PARAM_WEATHER = $line;
			next;
		} elsif ( $line =~ s/^\@topic[ \t]+// ) {
			$PARAM_TOPIC = $line;
			$RSS_TITLE[$RSS_N] = $line;
			next;
		} elsif ( $line =~ s/^\@foot[ \t]+// ) {
			$PARAM_FOOT = $line;
			next;
		}

		if ( $line =~ s/^\@title[ \t]+// ) {
			&CloseSection( $sectionmode );
			$titleflag = 1;
			$PARAM_TITLE = $line;
			$PARAM_CATEGORY = '';
			$NTITLE++;
			if ( ($NTITLE > 1) || ($PARAM_TOPIC ne "") ) {
				$RSS_N++;
			}
			$RSS_YEAR[$RSS_N] = $year;
			$RSS_MONTH[$RSS_N] = $month;
			$RSS_PART[$RSS_N] = $part;
			$RSS_DATE[$RSS_N] = $day;
			$RSS_TITLE[$RSS_N] = $line;
			$RSS_NTITLE[$RSS_N] = $NTITLE;
			$RSS_DESCRIPTION[$RSS_N] = '';
			$RSS_LINKURL[$RSS_N] = sprintf( "%04d%02d%s.html#$ANCHOR%02d%02d", $year, $month, $PARTS[$part], $day, $NTITLE );
			$RSS_TIME[$RSS_N] = $PARAM_TIME;
			$nsection = 0;
			$nsection2 = 0;
			$sectionmode = -1;
			next;
		} elsif ( $line =~ s/^\@category[ \t]+// ) {
			$PARAM_CATEGORY = $line;
			next;
		} elsif ( $line =~ s/^\@macro[ \t]+// ) {
			@sp = split( $FS, $line );
			$macroname = $sp[0];
			$macrovalue = $line;
			$macrovalue =~ s/^${macroname}//;
			$PARAMREPLACE_Key{$NPARAMREPLACE} = $macroname;
			$PARAMREPLACE_Obj{$macroname} = $macrovalue;
			$NPARAMREPLACE++;
			next;
		} elsif ( $line =~ s/^\@time[ \t]+// ) {
			if ( $line =~ m/^file/ ) {
				$PARAM_TIME = $PARAM_TIME_FILE;
				$RSS_TIME[$RSS_N] = $PARAM_TIME_FILE;
			} elsif ( $line =~ s/^full,[ \t]*// ) {
				$PARAM_TIME = $line;
				$RSS_TIME[$RSS_N] = $PARAM_TIME;
			} elsif ( $line =~ m/([0-9][0-9]):([0-9][0-9]):([0-9][0-9])/ ) {
				($time_h, $time_m, $time_s ) = ( $1, $2, $3 );
				$time_h =~ s/^0//;
				$time_m =~ s/^0//;
				$time_s =~ s/^0//;
				$time_daycarryup = 0;
				if ( $time_h >= 24 ) {
					$time_h -= 24;
					$time_daycarryup++;
				}
				$PARAM_TIME = sprintf( "%04d/%02d/%02d %02d:%02d:%02d", 
				  $year, $month, $day+$time_daycarryup, $time_h, $time_m, $time_s
				);
				$RSS_TIME[$RSS_N] = $PARAM_TIME;
			} elsif ( $line =~ m/([0-9][0-9]):([0-9][0-9])/ ) {
				($time_h, $time_m ) = ( $1, $2 );
				$time_h =~ s/^0//;
				$time_m =~ s/^0//;
				$time_daycarryup = 0;
				if ( $time_h >= 24 ) {
					$time_h -= 24;
					$time_daycarryup++;
				}
				$PARAM_TIME = sprintf( "%04d/%02d/%02d %02d:%02d:%02d", 
				  $year, $month, $day+$time_daycarryup, $time_h, $time_m, 0
				);
				$RSS_TIME[$RSS_N] = $PARAM_TIME;
			}
			next;
		} else {
			if ( $titleflag ) {
				$titleflag = 0;
				if ( $NTITLE > 1 ) {
					$DIARYLINE[$DIARYLINES++] = &SPrintDiaryTitleClose( $year, $month, $day, $wday, $part, $NTITLE-1, $PARAM_TITLE, $PARAM_CATEGORY, $PARAM_TIME );
				}
				$DIARYLINE[$DIARYLINES++] = '';
				if ( $PARAM_CATEGORY ne '' ) {
					$RSS_SUBJECT[$RSS_N] = $PARAM_CATEGORY;
				}
				$DIARYLINE[$DIARYLINES++] = &SPrintDiaryTitle( $year, $month, $day, $wday, $part, $NTITLE, $PARAM_TITLE, $PARAM_CATEGORY, $PARAM_TIME );
			}
			if ( $line =~ /^\@s1/ ) {
				&CloseSection( $sectionmode );
				$nsection++;
				$line = "<P class=\"s\">";
				$sectionmode = 0;
				if ( $nsection2 > 1 ) {
					$nsection2++;
				}
			} elsif ( $line =~ /^\@s2/ ) {
				$s = substr( $sections, $nsection, 1 );
				$line = sprintf( "<A NAME=\"$ANCHOR%02d%02d%s\" HREF=\"%04d%02d%s.html#$ANCHOR%02d%02d%s\"><SPAN class=\"smark\">%s</SPAN></A>",
				  $day, $NTITLE, $S, $year, $month, $PARTS[$part], $day,
				  $NTITLE, $S, $SENTENSEMARK
				);
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<P>";
#				}
			} elsif ( $line =~ /^\@s/ ) {
				&CloseSection( $sectionmode );
				$nsection++;
				$S = substr( $sections, $nsection, 1 );
				$line = sprintf("<P class=\"s\"><A NAME=\"$ANCHOR%02d%02d%s\" HREF=\"%04d%02d%s.html#$ANCHOR%02d%02d%s\"><SPAN class=\"smark\">%s</SPAN></A>",
				  $day, $NTITLE, $S, $year, $month, $PARTS[$part], $day,
				  $NTITLE, $S, $SENTENSEMARK
				);
				$sectionmode = 0;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<P>";
#				}
			} elsif ( $line =~ /^\@qcode/ ) {
				&CloseSection( $sectionmode );
				$line = "<BLOCKQUOTE class=\"qcode\"><PRE class=\"pre_qcode\"><CODE class=\"code_qcode\">";
				$sectionmode = 1;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<BLOCKQUOTE><PRE>";
#				}
			} elsif ( $line =~ /^\@q/ ) {
				&CloseSection( $sectionmode );
				$line = "<BLOCKQUOTE class=\"q\"><PRE class=\"q\">";
				$sectionmode = 2;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<BLOCKQUOTE><PRE>";
#				}
			} elsif ( $line =~ /^\@p/ ) {
				&CloseSection( $sectionmode );
				$line = "<P class=\"s\">";
				$sectionmode = 0;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<P>";
#				}
			} elsif ( $line =~ /^\@close/ ) {
				&CloseSection( $sectionmode );
				$sectionmode = -2;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n";
#				}
				next;
			} elsif ( $line =~ /^\@c/ ) {
				&CloseSection( $sectionmode );
				$line = "<DIV ALIGN=\"center\" class=\"center\"><BIG><B>";
				$sectionmode = 3;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<DIV ALIGN=\"center\"><BIG><B>";
#				}
			} elsif ( $line =~ /^\@ul/ ) {
				&CloseSection( $sectionmode );
				$line = "<UL class=\"ul\">";
				$sectionmode = 4;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<UL>";
#				}
			} elsif ( $line =~ /^\@ol/ ) {
				&CloseSection( $sectionmode );
				$line = "<OL class=\"ol\">";
				$sectionmode = 5;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<OL>";
#				}
			} elsif ( $line =~ /^\@f/ ) {
				&CloseSection( $sectionmode );
				$nfootnote++;
				$line = ''; # "<HR class=\"hr_footnote\">\n";
				if ( $sectionmode != 6 ) {
					$line = '';
				}
				$line .= sprintf("<DL class=\"dl_footnote\"><DD class=\"dd_footnote\"><P class=\"s_footnote\"><SMALL class=\"small_footnote\"><A NAME=\"$ANCHOR%02dF%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02dF%02d\">%s%d</A>:",
				  $day, $nfootnote, $year, $month, $PARTS[$part], $day,
				  $nfootnote, $FOOTNOTEMARK, $nfootnote
				);
				$sectionmode = 6;
				$nsection2++;
#				if ( $nsection2 > 1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "\n<DL><DD>";
#				}
			} elsif ( $line =~ /^\@br/ ) {
				$line = "<BR clear=\"all\" class=\"clearall\">";
				$RSS_DESCRIPTION[$RSS_N] .= "\n<BR clear=\"all\">";
			} else {
				if ( $sectionmode == -1 ) {
					$RSS_DESCRIPTION[$RSS_N] .= "<P>$line";
					$line = "<P class=\"s\">" . $line;
					$sectionmode = 0;
					$nsection2++;
				} else {
					if ( $sectionmode == 1 ) {
						$line =~ s:[&]:&amp;:g;
						$line =~ s:[<]:&lt;:g;
						$line =~ s:[>]:&gt;:g;
						$line =~ s:[&]amp;amp;:&amp;:g;
						$line =~ s:[&]amp;lt;:&lt;:g;
						$line =~ s:[&]amp;gt;:&gt;:g;
						$line =~ s:[&]amp;ampamp;:&amp;amp;:g;
						$line =~ s:[&]amp;amplt;:&amp;lt;:g;
						$line =~ s:[&]amp;ampgt;:&amp;gt;:g;
					}
					$RSS_DESCRIPTION[$RSS_N] .= "$line";
				}
			}
		}
		$DIARYLINE[$DIARYLINES++] = $line;
	}
	if ( $RSS_DESCRIPTION[$RSS_N] eq '' ) {
		$RSS_DESCRIPTION[$RSS_N] = '(no description)';
	}
	if ( $sectionmode >= -1 ) {
		$DIARYLINE[$DIARYLINES++] = "<BR clear=\"all\" class=\"clearall\">";
	}
	&CloseSection( $sectionmode );
	close( FIN );
}

########################################################################
### KEEPDIRν
#
sub Setup_KEEPDIR {
	local( $cmd, $fin, $line, $i );
	local( $FIN );
	local( $FOUT );
	local( $umaskback );


	if ( !(-e $KEEPDIR) ) {
		if ( !(-e $GETDIR) ) {
			$umaskback = umask( oct($DIARY_GETDIR_PERM) ^ 0777 );
			mkdir( $GETDIR, oct($DIARY_GETDIR_PERM) ) || die "cannot create [$GETDIR].";
			umask( $umaskback );
		}
		$umaskback = umask( oct($DIARY_KEEPDIR_PERM) ^ 0777 );
		mkdir( $KEEPDIR, oct($DIARY_KEEPDIR_PERM) ) || die "cannot create [$KEEPDIR].";
		umask( $umaskback );
	}

	umask( oct($DIARY_KEEP_PERM) ^ 0666 );

	while ( <keep/*> ) {   # */
		$src = $_;
		$dst = $_;
		$dst =~ s:keep/::;
		$dst = $KEEPDIR . $SLASH . $dst;
		if ( !( -e $dst ) ) {
			$FIN = $src; open( FIN ) || die "cannot open [$src].";
			$FOUT = ">$dst"; open( FOUT ) || die "cannot open [$dst].";
			while ( <FIN> ) {
				print FOUT;
			}
			close( FIN );
			close( FOUT );
		}
	}
	umask( $umaskback );

}

########################################################################
### ɽƥν 
#
sub Setup_ITEMS {
	local( $cmd, $fin, $line, $i );
	local( $FIN );

	if ( $WDAYS[0] eq '' ) {
		$i = 0;
		$fin = $KEEPDIR . $SLASH . $ITEMNAME;
		$cmd = $NKFCMD . ' -e ' . $fin . "|";
		$FIN = $cmd; open( FIN ) || die "cannot open [$cmd].";
		while ( $line = <FIN> ) {
			$line =~ s/[\012\015]+//;
# print "[WDAYS: $i: $line]\n";
			$WDAYS[$i++] = $line;
		}
		close( FIN );
		$TITLEMARK = $WDAYS[7];
		$SENTENSEMARK = $WDAYS[8];
		$FOOTNOTEMARK = $WDAYS[9];
		$FOOTSTARTMARK = $WDAYS[10];
		$FOOTENDMARK = $WDAYS[11];
	}
}

########################################################################
### ̾ν 
#
sub Setup_PARTS {
	$PARTS[0] = 'a';
	$PARTS[1] = 'b';
	$PARTS[2] = 'c';
}

########################################################################
### ѥ᡼ִǡ١ν 
#
sub MakeParamReplaceDatabase {
	local( $fin ) = @_;
	local( $cmd, $s1, $s2, $s );
	local( @sp );
	local( $FIN );

	$FS = "[ \t]+";
	$NPARAMREPLACE = 0;
	$cmd = $NKFCMD . ' -e ' . $fin . "|";
	$FIN = $cmd; open( FIN ) || die "cannot open [$cmd].";
	while (<FIN>) {
		s/[\012\015]+//;
		s/^[ \t]+//;
		@sp = split( $FS );
		if ( $sp[0] =~ m/#/ ) {
			next;
		}
		if ( length($_) < 1 ) {
			next;
		}
		$s1 = $sp[0];
		$s2 = $_;
		$s = '^' . $s1 . $FS, $s2 =~ s/$s//;
		$PARAMREPLACE_Key{$NPARAMREPLACE} = $s1;
		$PARAMREPLACE_Obj{$s1} = $s2;
		$NPARAMREPLACE++;
	}
	close( FIN );
}

########################################################################
### URLִǡ١ν 
#
sub MakeReplaceDatabase {
	local( $fin ) = @_;
	local( $cmd, @sp );
	local( $FIN );

	$FS = "[ \t]+";
	$NREPLACE = 0;
	$cmd = $NKFCMD . ' -e ' . $fin . "|";
	$FIN = $cmd; open( FIN ) || die "cannot open [$fin].";
	while (<FIN>) {
		s/[\012\015]+//;
		s/^[ \t]+//;
		@sp = split( $FS );
		if ( $sp[0] =~ m/#/ ) {
			next;
		}
		if ( length($_) < 1 ) {
			next;
		}
		$REPLACE_Key[$NREPLACE] = $sp[0];
		$REPLACE_Name{$sp[0]} = $sp[1];
		$REPLACE_Obj{$sp[0]} = $sp[2];
		$NREPLACE++;
	}
	close( FIN );
}

########################################################################
### ִURLִǡ١ˤִ 
#
sub Replace {
	local( $line, $year, $month, $part, $day ) = @_;
	local( $Y, $M, $p, $s, $ss, $i, $i2, $n, $pt, $le, $s1, $s2 );
	local( $key, $name, $param, @params, $paramtype );

	if ( $line !~ m/\@/ ) {
		return ($line);
	}

	while (!0) {
		$pt = 0;
		$paramtype = 0;
		$line =~ s:\\[/]:&#47;:g;
		if ( $line =~ m:\@\/[^/]*\/[^/]*\/: ) {
			$pt = length($`);
			$s = $&;
		} else {
			$paramtype = 1;
			if ( $line =~ m:\@\>[^>]*\>[^>]*\>: ) {
				$pt = length($`);
				$s = $&;
			} else {
				last;
			}
		}
		$s1 = substr( $line, 0, $pt );
		$s2 = substr( $line, $pt+length($s) );
# print "[$s1][$s][$s2]\n";
		$key = $s;
		if ( $paramtype == 0 ) {
			$key =~ s:\@\/([^/]*)\/.*$:\1:;
		} else {
			$key =~ s:\@\>([^>]*)\>.*$:\1:;
		}
# print "[$key]\n";
		if ( defined $PARAMREPLACE_Obj{$key} ) {
			$param = $s;
			if ($paramtype == 0) {
				$param =~ s:\@\/[^/]*\/([^/]*)\/:\1:;
			} else {
				$param =~ s:\@\>[^>]*\>([^>]*)\>:\1:;
			}
# print "[$param]\n";
			$param =~ s/\\[,]/&#44;/g;
			$n = ( @params = split( ",", $param ) );
			for ( $i=0; $i<=$n; $i++ ) {
				$params[$i] =~ s/^[ ]*(.*)[ ]*$/\1/;
			}
			$param = $PARAMREPLACE_Obj{$key};
			for ( $i=0; $i<=$n; $i++ ) {
				if ( $i == 0 ) {
					$s = join( " ", @params );
				} else {
					$s = $params[$i-1];
				}
				$ss = $s;
				$param =~ s/\&\#044;/,/g;
				if ( $param =~ m:\@${i}a: ) {
					# Τޤ
					$param =~ s:\@${i}a:$s:g;
				}
				if ( $param =~ m:\@${i}b: ) {
					# "-"ʤ
					$s = $ss;
					$s =~ s:\-::g;
					$param =~ s:\@${i}b:$s:g;
				}
				if ( $param =~ m:\@${i}c: ) {
					# EUCURL󥳡
					$s = &Encode2URL( $ss, "EUC" );
					$param =~ s:\@${i}c:$s:g;
				}
				if ( $param =~ m:\@${i}d: ) {
					# SJISURL󥳡
					$s = &Encode2URL( $ss, "SJIS" );
					$param =~ s:\@${i}d:$s:g;
				}
				if ( $param =~ m:\@${i}e: ) {
					# UTF8URL󥳡
					$s = &Encode2URL( $ss, "UTF8" );
					$param =~ s:\@${i}e:$s:g;
				}
				if ( $param =~ m:\@${i}f: ) {
					# ʹľ
					$i2 = ( $i ? $i-1 : $i );
					$s = join( "", @params[$i2 .. $n] );
					$param =~ s:\@${i}f:$s:g;
				}
				if ( $param =~ m:\@${i}g: ) {
					# ʹ" "Ϣ
					$i2 = ( $i ? $i-1 : $i );
					$s = join( " ", @params[$i2 .. $n] );
					$param =~ s:\@${i}g:$s:g;
				}
				if ( $param =~ m:\@${i}h: ) {
					# ʹ","Ϣ
					$i2 = ( $i ? $i-1 : $i );
					$s = join( ",", @params[$i2 .. $n] );
					$param =~ s:\@${i}h:$s:g;
				}
			}
			$line = $s1 . $param . $s2;
		} elsif ( defined $REPLACE_Obj{$key} ) {
			$name = $s;
			if ($paramtype == 0) {
				$name =~ s:\@\/[^/]*\/([^/]*)\/:\1:;
			} else {
				$name =~ s:\@\>[^>]*\>([^>]*)\>:\1:;
			}
# print "[$name]\n";
			if ( $name eq '' ) {
				$name = $REPLACE_Name{$key};
			}
			$line = $s1 . "<A HREF=\"" . $REPLACE_Obj{$key} . "\">" . $name . '</A>' . $s2;
		} else {
# print "No Key [$key].\n";
			$s =~ s:\@:\\&#GNS;:;  # Ū
			$line = $s1 . $s . $s2;
		}
	}
# print "Replaced: $line\n";

	$line =~ s:\\&#GNS;:\@:g;  # Ūפ᤹

	$line =~ s:\@/lastmodified/:$LASTMODIFIED:g;
	$s = sprintf( "%04d", $year-1 );
	$line =~ s:\@/lastyear/:$s:g;
	$s = sprintf( "%04d", $year );
	$line =~ s:\@/year/:$s:g;
	$s = sprintf( "%04d", $year+1 );
	$line =~ s:\@/nextyear/:$s:g;
	$s = sprintf( "%02d", $month );
	$line =~ s:\@/month/:$s:g;
	$s = sprintf( "%02d", $day );
	$line =~ s:\@/date/:$s:g;
	$s = $PARTS[$part];
	$line =~ s:\@/part/:$s:g;
	$s = $part+1;
	$line =~ s:\@/PART/:$s:g;

	$s = "$GENERATOR";
	$line =~ s:\@/DIARY_GENERATOR/:$s:g;
	$s = $DIARY_TITLE;
	$line =~ s:\@/DIARY_TITLE/:$s:g;
	$s = $DIARY_AUTHOR;
	$line =~ s:\@/DIARY_AUTHOR/:$s:g;
	$s = $DIARY_EMAIL;
	$line =~ s:\@/DIARY_EMAIL/:$s:g;
	$s = $DIARY_EMAIL;
	$s =~ s/[@]/ @(at) /g;
	$s =~ s/[.]/ .(dot) /g;
	$line =~ s:\@/DIARY_EMAIL_NOSPAM/:$s:g;
	$s = $DIARY_DESCRIPTION;
	$line =~ s:\@/DIARY_DESCRIPTION/:$s:g;
	$s = $DIARY_COPYRIGHT;
	$line =~ s:\@/DIARY_COPYRIGHT/:$s:g;
	$s = $CHARSET;
	$line =~ s:\@/DIARY_CHARSET/:$s:g;
	$s = $DIGESTNAME;
	$line =~ s:\@/DIARY_DIGESTNAME/:$s:g;
	$s = $RSSNAME;
	$line =~ s:\@/DIARY_RSSNAME/:$s:g;
	$s = $LASTUPLOADNAME;
	$line =~ s:\@/DIARY_LASTUPLOADNAME/:$s:g;
	$s = $PUTDIR;
	$line =~ s:\@/DIARY_PUTDIR/:$s:g;
	$s = $URLBASENAME;
	$line =~ s:\@/DIARY_URLBASENAME/:$s:g;

	if ( $line =~ m:\@/prevfile/: ) {
		$Y = $year;
		$M = $month;
		$p = $part;
		$p--;
		if ( $p < 0 ) {
			$p = 2;
			$M--;
			if ( $M < 1 ) {
				$M = 12;
				$Y--;
			}
		}
		$s = sprintf( '%04d%02d%s.html', $Y, $M, $PARTS[$p] );
		$line =~ s:\@/prevfile/:$s:g;
	}
	if ( $line =~ m:\@/nextfile/: ) {
		$Y = $year;
		$M = $month;
		$p = $part;
		$p++;
		if ( $p > 2 ) {
			$p = 0;
			$M++;
			if ( $M > 12 ) {
				$M = 1;
				$Y++;
			}
		}
		$s = sprintf( '%04d%02d%s.html', $Y, $M, $PARTS[$p] );
		$line =~ s:\@/nextfile/:$s:g;
	}

	while (!0) {
		if ( $line !~ m:\@[*]: ) {
			last;
		}
		$FOOTNOTE_REFER++;
		$s = sprintf("<SMALL class=\"small_tofootnote\"><A HREF=\"%04d%02d%s.html#$ANCHOR%02dF%02d\">%s%d</A></SMALL>",
		  $year, $month, $PARTS[$part], $day, $FOOTNOTE_REFER, $FOOTNOTEMARK,
		  $FOOTNOTE_REFER
		);
		$line =~ s:\@[*]:$s:;
	}

	return ($line);
}

########################################################################
### եƤִʤcat 
#
sub CatFile {
	local( $FOUT, $fin, $year, $month, $part ) = @_;
	local( $cmd, $line, $s );
	local( $FIN );

	$cmd = $NKFCMD . ' -e ' . $fin . "|";
	$FIN = $cmd; open( FIN ) || die "cannot open [$cmd].";
	while ( $line = <FIN> ) {
		$s = &Replace( $line, $year, $month, $part, 0 );
		print $FOUT $s;
	}
	close( FIN );
}

########################################################################
### դܤ 
#
sub GetDiaryPart {
	local( $year, $month, $day ) = @_;
	local( $days, $i );

	$STARTDATE = 1;
	$PART = 0;
	$days = 10;
	if ( $day >= $STARTDATE+$days ) {
		$STARTDATE += $days;
		$PART++;
	}
	if ( $day >= $STARTDATE+$days ) {
		$STARTDATE += $days;
		$PART++;
		$days++;  # 31 
	}
	$ENDDATE = $STARTDATE + $days;
	&YMD2DAYS( $year, $month, $STARTDATE );
	if ($ENDDATE > $DAYS[$month] + 1) {
		$ENDDATE = $DAYS[$month] + 1;
	}
}

########################################################################
### ١ե 
#
sub BindDiaryBase {
	local( $year, $month, $day, $startdate ) = @_;
	local( $enddate, $part, $i, $fout, $fout2, $cmd, $fin, $line, $needinterval );
	local( $umaskback );
	local( $FOUT );

	&GetDiaryPart( $year, $month, $day );
	$needinterval = 0;
	$startdate = $STARTDATE;
	$enddate = $ENDDATE;
	$part = $PART;
	$RENDERTEST = 0;

	$fout = $TMPDIR . $SLASH . '%tmp1.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $BASEHEADERNAME, $year, $month, $part );
	&PrintStart( *FOUT );

	for ( $i=$startdate; $i<$enddate; $i++ ) {
		$fin = &MakeMasterFileName( $year, $month, $i );
		if ( !(-e $fin) ) {
			if ( !$PRINTNOEXISTDAY ) {
				next;
			}
		}
		if ( $needinterval ) {
			&PrintInterval( *FOUT );
		}
		&PrintDiary( *FOUT, $year, $month, $i, $part, 0 );
		$needinterval = !0;
	}
	&PrintTerminate( *FOUT );
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $BASEFOOTERNAME, $year, $month, $part );
	close( FOUT );

	umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$fout2 = sprintf( $PUTDIR . $SLASH . '%04d%02d%s.html', $year, $month, $PARTS[$part] );
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
# print cmd;
	system( $cmd );
	umask( $umaskback );
}

########################################################################
### ȥե 
#
sub BindDiaryDigest {
	local( $totaldays ) = @_;
	local( $days, $year, $month, $day, $part, $i, $fout, $fout2, $cmd, $fin, $line, $needinterval, $istoday );
	local( $umaskback );
	local( $FOUT );

	$RSS_N = 0;
	$needinterval = 0;
	$days = $totaldays;
	&DAYS2YMD( $days );
	$year = $YEAR;
	$month = $MONTH;
	$day = $DATE;
	$RENDERTEST = 0;

	$fout = $TMPDIR . $SLASH . '%tmp2.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $DIGESTHEADERNAME, $year, $month, $part );
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $DIGESTPREMEMONAME, $year, $month, $part );

	&PrintStart( *FOUT );
	for ( $i=0; $i<$DIGESTDAYS; $i++ ) {
		$days = $totaldays-$i;
		if ( $days < 0 ) {
			last;
		}
		&DAYS2YMD( $days );
		$year = $YEAR;
		$month = $MONTH;
		$day = $DATE;
		&GetDiaryPart( $year, $month, $day );
		$part = $PART;
		$fin = &MakeMasterFileName( $year, $month, $day );
		if ( !(-e $fin) ) {
			if ( !$PRINTNOEXISTDAY ) {
				next;
			}
		}
		if ( $needinterval ) {
			&PrintInterval( *FOUT );
		}
		$istoday = 2;
		if ( $i == 0 ) {
			$istoday = 1;
		}
		&PrintDiary( *FOUT, $year, $month, $day, $part, $istoday );
		$needinterval = !0;
	}
	&PrintTerminate( *FOUT );

	&CatFile( *FOUT, $KEEPDIR . $SLASH . $DIGESTPOSTMEMONAME, $year, $month, $part );
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $DIGESTFOOTERNAME, $year, $month, $part );
	close( FOUT );

	umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$fout2 = $PUTDIR . $SLASH . $DIGESTNAME;
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
# print cmd;
	system( $cmd );
	umask( $umaskback );
}

########################################################################
### ƥȥե 
#
sub BindDiaryTest {
	local( $totaldays ) = @_;
	local( $days, $year, $month, $day, $part, $i, $fout, $fout2, $cmd );
	local( $umaskback );
	local( $FOUT );

	$fout = $TMPDIR . $SLASH . '%tmp2.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";
	$RENDERTEST = 1;

	&PrintStart( *FOUT );
	for ( $i=0; $i<1; $i++ ) {
		$days = $totaldays-$i;
		if ( $days < 0 ) {
			last;
		}
		&DAYS2YMD( $days );
		$year = $YEAR;
		$month = $MONTH;
		$day = $DATE;
		&GetDiaryPart( $year, $month, $day );
		$part = $PART;
		&PrintDiary( *FOUT, $year, $month, $day, $part, 0 );
	}
	&PrintTerminate( *FOUT );
	close( FOUT );

	$fout2 = $TMPDIR . $SLASH . 'test.html';
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
# print cmd;
	system( $cmd );

	$fout2 = $TMPDIR . $SLASH . 'tblist.txt';
	$cmd = $NKFCMD . ' ' . $NKFCODE . '>' . $fout2;
# print cmd;
	$FOUT = "|$cmd"; open( FOUT ) || die "cannot open [$cmd].";
	for ( $i=1; $i<=$RSS_N; $i++ ) {
		$s = &Replace( $RSS_TITLE[$i], $RSS_YEAR[$i], $RSS_MONTH[$i], $RSS_PART[$i], $RSS_DATE[$i] );
		while ( $s =~ s:<[^<>]*>::g ) {}
		print FOUT "$s\n";
		$s = &Replace( $RSS_DESCRIPTION[$i], $RSS_YEAR[$i], $RSS_MONTH[$i], $RSS_PART[$i], $RSS_DATE[$i] );
		while ( $s =~ s:<[^<>]*>: :g ) {}
		$s =~ s:[ ]+: :g;
		$s =~ s:\n::g;
		if ( $s =~ s:^(([\x00-\x7f]|[\x80-\xff][\x80-\xff]){120}).*$:\1: ) {
			$s .= "...";
		}
		print FOUT "$s\n";
		$s = $URLBASENAME . $RSS_LINKURL[$i];
		print FOUT "$s\n";
	}
	close( FOUT );

	umask( $umaskback );
}

########################################################################
###  
#
sub Setup_DAYS {
	local( $year ) = @_;

	$DAYS[1] = 31;
	$DAYS[2] = 28;
	$DAYS[3] = 31;
	$DAYS[4] = 30;
	$DAYS[5] = 31;
	$DAYS[6] = 30;
	$DAYS[7] = 31;
	$DAYS[8] = 31;
	$DAYS[9] = 30;
	$DAYS[10] = 31;
	$DAYS[11] = 30;
	$DAYS[12] = 31;
	if (((($year % 4) == 0) && (($year % 100) != 0)) || (($year % 400) == 0)) {
		$DAYS[2] = 29;
	}
}

########################################################################
### ǯ 
#
sub Setup_DAYS1 {
	local( $year ) = @_;

	$DAYS1 = 365;
	if (((($year % 4) == 0) && (($year % 100) != 0)) || (($year % 400) == 0)) {
		$DAYS1++;
	}
}

########################################################################
### ǯ1980/01/01ѻաפ 
#
sub YMD2DAYS {
	local( $year, $month, $day ) = @_;
	local( $days, $i );

	if ( $day < 1 ) {
		&error_arg( 'date<1' );
		$day = 1;
	}
	&Setup_DAYS( $year );
	$days = $DAYS[$month];
	if ( $day > $days ) {
		&error_arg('date>end ' . $day . '>' . $days);
		$day = $days;
	}

	$TOTALDAYS = 0;
	for ( $i=1980; $i<$year; $i++ ) {
		&Setup_DAYS1( $i );
		$TOTALDAYS += $DAYS1;
	}
	for ( $i=1; $i<$month; $i++ ) {
		$TOTALDAYS += $DAYS[$i];
	}
	$TOTALDAYS += $day-1;

	$WDAY = ($TOTALDAYS + 2) % 7;  # SUN->SAT 
}

########################################################################
### 1980/01/01ѻաפǯ 
#
sub DAYS2YMD {
	local($totaldays) = @_;

	$WDAY = ($TOTALDAYS + 2) % 7;  # SUN->SAT 

	for ( $YEAR=1980; $YEAR<2100; $YEAR++ ) {
		&Setup_DAYS1( $YEAR );
		if ( $DAYS1 > $totaldays ) {
			last;
		}
		$totaldays -= $DAYS1;
	}

	&Setup_DAYS( $YEAR );
	for ( $MONTH = 1; $MONTH <= 12; $MONTH++ ) {
		if ( $DAYS[$MONTH] > $totaldays ) {
			last;
		}
		$totaldays -= $DAYS[$MONTH];
	}

	$DATE = $totaldays+1;
}

########################################################################
### ե顼ɽ
#
sub error_arg {
	local($s) = @_;

	print 'error_arg ' . $s. "\n";
}

########################################################################
### ֺǿաפɤ߽Ф 
#
sub ReadLastUpload {
	local( $digestdiary, $lastupload );
	local( $name, $value );
	local( $FIN );

	undef @LASTUPLOAD;

	# digestdiary.htmlʤlastuploadä
	$digestdiary = $PUTDIR . $SLASH . $DIGESTNAME;
	$lastupload = $KEEPDIR . $SLASH . $LASTUPLOADNAME;
	if ( !(-e $digestdiary) ) {
		if ( -e $lastupload ) {
			unlink $lastupload;
			return;
		}
	}

	$FIN = $lastupload;
	if ( !open( FIN ) ) {
		return;
	}
	$_ = <FIN>;
	( $YEAR, $MONTH, $DATE ) = split;
	while (<FIN>) {
		chomp;
		( $name, $value ) = split('=');
		$LASTUPLOAD{ $name } = $value;
	}
	close( FIN );
}

########################################################################
### ֺǿաפϿ 
#
sub WriteLastUpload {
	local( $year, $month, $day ) = @_;
	local( $fout, $cmd );
	local( $umaskback );
	local( $FOUT );

	$fout = $KEEPDIR . $SLASH . $LASTUPLOADNAME;
	$umaskback = umask( oct($DIARY_KEEP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";

	print FOUT "$year $month $day\n";
	printf( FOUT "makeindex=%d\n", $LASTUPLOAD{"makeindex"}+0 );
	printf( FOUT "updateping=%d\n", $LASTUPLOAD{"updateping"}+0 );

	close( FOUT );
	umask( $umaskback );
}

########################################################################
### digest RSSϤ
#
sub PutDigestRSS {
	local( $fout, $cmd, $s, $ce, $i, $ncw, @cw );
	local( $umaskback );
	local( $FOUT );
	local( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
	local( $time_yyyy, $time_mm, $time_dd, $time_h, $time_m, $time_s );
	local( $creator );

	$fout = $PUTDIR . $SLASH . $RSSNAME;
	$cmd = "|" . $NKFCMD . ' --utf8 >' . $fout;
	$umaskback = umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$FOUT = $cmd; open( FOUT ) || die "cannot open [$cmd].";

	print FOUT "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
	print FOUT "<rdf:RDF\n";

	$s = "  xmlns=\"http://purl.org/rss/1.0/\"\n" .
	     "  xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n" .
	     "  xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n" .
	     "  xmlns:syn=\"http://purl.org/rss/1.0/modules/syndication/\"\n" .
	     "  xmlns:content=\"http://purl.org/rss/1.0/modules/content/\"\n" .
	     "  xmlns:trackback=\"http://madskills.com/public/xml/rss/module/trackback/\"\n" .
	     "  xml:lang=\"ja\">\n" .
	     "";
	$s = &SPrintDigestRSSHeader_Config2( $s );
	print FOUT $s;

	$s = $URLBASENAME . $RSSNAME;
	print FOUT " <channel rdf:about=\"" . $s . "\">\n";
	$s = $DIARY_TITLE;
	while ( $s =~ s:<[^<>]*>::g ) {}
	$s =~ s:\&[^;]*;::g;
	$s =~ s:\&::g;
	print FOUT "  <title>" . $s . "</title>\n";
	$s = $URLBASENAME . $DIGESTNAME;
	print FOUT "  <link>" . $s . "</link>\n";
	$s = $DIARY_DESCRIPTION;
	while ( $s =~ s:<[^<>]*>::g ) {}
	$s =~ s:\&[^;]*;::g;
	$s =~ s:\&::g;
	print FOUT "  <description>" . $s . "</description>\n";
	print FOUT "  <dc:language>ja-jp</dc:language>\n";
	$s = $DIARY_COPYRIGHT;
	while ( $s =~ s:<[^<>]*>::g ) {}
	$s =~ s:\&[^;]*;::g;
	$s =~ s:\&::g;
	print FOUT "  <dc:rights>" . $s . "</dc:rights>\n";
	( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime( $SYSTIME );
	$s = sprintf( "%04d-%02d-%02dT%02d:%02d:%02d%s",
	  $year+1900, $mon+1, $mday, $hour, $min, $sec, $TIMEZONESTR
	);
	print FOUT "  <dc:date>" . $s . "</dc:date>\n";
	$s = $DIARY_AUTHOR;
	while ( $s =~ s:<[^<>]*>::g ) {}
	$s =~ s:\&[^;]*;::g;
	$s =~ s:\&::g;
	print FOUT "  <dc:publisher>" . $s . "</dc:publisher>\n";
	$s = $DIARY_AUTHOR;
	while ( $s =~ s:<[^<>]*>::g ) {}
	$s =~ s:\&[^;]*;::g;
	$s =~ s:\&::g;
	$creator = $s;
	print FOUT "  <dc:creator>" . $creator . "</dc:creator>\n";
	$s = $GENERATOR;
	$s = "diary";
	print FOUT "  <dc:subject>" . $s . "</dc:subject>\n";
	print FOUT "  <items>\n";
	print FOUT "   <rdf:Seq>\n";

	for ( $i=1; $i<=$RSS_N; $i++ ) {
		$s = $URLBASENAME . $RSS_LINKURL[$i];
		print FOUT "   <rdf:li rdf:resource=\"" . $s . "\" />\n";
	}

	print FOUT "   </rdf:Seq>\n";
	print FOUT "  </items>\n";
	print FOUT " </channel>\n";
	print FOUT "\n";

	for ( $i=1; $i<=$RSS_N; $i++ ) {
		$s = $URLBASENAME . $RSS_LINKURL[$i];
		print FOUT " <item rdf:about=\"" . $s . "\">\n";
		$s = &Replace( $RSS_TITLE[$i], $RSS_YEAR[$i], $RSS_MONTH[$i], $RSS_PART[$i], $RSS_DATE[$i] );
		while ( $s =~ s:<[^<>]*>: :g ) {}
		$s =~ s:\&[^;]*;::g;
		$s =~ s:\&::g;
		print FOUT "  <title>" . $s . "</title>\n";
		$s = $URLBASENAME . $RSS_LINKURL[$i];
		print FOUT "  <link>" . $s . "</link>\n";
		$s = &Replace( $RSS_DESCRIPTION[$i], $RSS_YEAR[$i], $RSS_MONTH[$i], $RSS_PART[$i], $RSS_DATE[$i] );
		$ce = $s;
		while ( $s =~ s:<[^<>]*>: :g ) {}
		$s =~ s:\&[^;]*;::g;
		$s =~ s:\&::g;
		$s =~ s:[ ]+: :g;
		$s =~ s:\n::g;
		if ( $s =~ s:^(([\x00-\x7f]|[\x80-\xff][\x80-\xff]){120}).*$:\1: ) {
			$s .= "...";
		}
		print FOUT "  <description>" . $s . "</description>\n";
		$ce =~ s/[[]/%5b/g;
		$ce =~ s/[]]/%5d/g;
#		$ce =~ s/\n/<br>/g;
		while ( $ce =~ s/(<[Aa] [^>]*)([Oo][Nn][A-Za-z]*[ \t]*=[ \t]*"[^"]*")(.*>)/\1\3/g ) {}
		print FOUT "  <content:encoded>\n";
		print FOUT "   <![CDATA[$ce]]>\n";
		print FOUT "  </content:encoded>\n";
#		$s = sprintf( "%04d-%02d-%02dT%02d:%02d:%02d%s", $RSS_YEAR[$i], $RSS_MONTH[$i], $RSS_DATE[$i], 0, 0, 0, $TIMEZONESTR );
		( $time_yyyy, $time_mm, $time_dd, $time_h, $time_m, $time_s ) = split( "[ /:]", $RSS_TIME[$i] );
		$time_yyyy =~ s/^0+//;
		$time_mm =~ s/^0+//;
		$time_dd =~ s/^0+//;
		$time_h =~ s/^0+//;
		$time_m =~ s/^0+//;
		$time_s =~ s/^0+//;
		$s = sprintf( "%04d-%02d-%02dT%02d:%02d:%02d%s", $time_yyyy+0, $time_mm+0, $time_dd+0, $time_h+0, $time_m+0, $time_s+0, $TIMEZONESTR );
		print FOUT "  <dc:date>" . $s . "</dc:date>\n";
		print FOUT "  <dc:creator>" . $creator . "</dc:creator>\n";
		$ncw = ( @cw = split( ",", $RSS_SUBJECT[$i] ) );
		for ( $j=0; $j<$ncw; $j++ ) {
			$cw[$j] =~ s:^[ \t]+::;
			$cw[$j] =~ s:[ \t]+$::;
			$s = &Replace( $cw[$j], $RSS_YEAR[$i], $RSS_MONTH[$i], $RSS_PART[$i], $RSS_DATE[$i] );
			while ( $s =~ s:<[^<>]*>: :g ) {}
			print FOUT "  <dc:subject>" . $s . "</dc:subject>\n";
		}
		print FOUT " </item>\n";
	}

	print FOUT "</rdf:RDF>\n";
	close( FOUT );
	umask( $umaskback );
}


########################################################################
### ƥʸʸ
#
sub MakeCategoryLinkStrings {
	local( $year, $str ) = @_;
	local( $retstr, @cw, $i, $ncw );

	$retstr = '';
	$ncw = ( @cw = split( ",", $str ) );
	for ( $i=0; $i<$ncw; $i++ ) {
		$cw[$i] =~ s:^[ \t]+::;
		$cw[$i] =~ s:[ \t]+$::;
		$retstr = sprintf("%s<A HREF=\"%04d_ca.html#W_%s\">%s</A>",
		  $retstr, $year, &Encode2URL($cw[$i], 'UTF8'), $cw[$i]
		);
		if ( $i != $ncw-1 ) {
			$retstr .= ', ';
		}
	}

	return ($retstr);
}

########################################################################
### URLʸؤΥ󥳡
#
sub Encode2URL {
	local( $in, $incode ) = @_;
	local( $s, $code, $cmd, $l, $i, $b );
	local( $umaskback );
	local( $retstr );
	local( $FIN_U );
	local( $FOUT_U );

# print "Encode2URL $s, $incode\n";
	if ( defined( $ENCCACHE{"$incode:$in"} ) ) {
		return ($ENCCACHE{"$incode:$in"});
	}

	$s = $in;
	$retstr = "";
	$code = 'sjis';
	$code = 'euc' if ( $incode eq "EUC" );
	$code = 'utf8' if ( $incode eq "UTF8" );
	if ( $code eq "utf8" ) {
		$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
		$FOUT_U = ">$TMPDIR/%eucin.txt"; open( FOUT_U );
		print FOUT_U $s;
		close( FOUT_U );
		$cmd = "$NKFCMD -E --utf8 $TMPDIR/%eucin.txt>$TMPDIR/%utf8out.txt";
		system( $cmd );
		$FIN_U = "$TMPDIR/%utf8out.txt"; open( FIN_U );
		$s = <FIN_U>;
		close( FIN_U );
		umask( $umaskback );
	} else {
		&jcode'convert( *s, $code, "euc" );
	}
	$l = length($s);
	for ( $i=0; $i<$l; $i++ ) {
		$b = unpack( "%C", $s );
# print "Encode2URL $i, $b\n";
		$retstr .= sprintf( "%%%02X", $b );
		$s = substr( $s, 1 );
	}

	$ENCCACHE{"$incode:$in"} = $retstr;
	$ENCCACHEENTRY[$N_ENCCACHEENTRY++] = "$incode:$in";

# print "return $retstr\n";
	return ($retstr);
}

########################################################################
### URLʸ󥨥󥳡ɥåɤ߹
#

sub ReadENCODECACHE {
	local( $line, $key, $value );
	local( $FIN_U );

	$N_ENCCACHEENTRY = 0;
	$FIN_U = $TMPDIR . $SLASH . $ENCODECACHENAME;
# print "Read FIN_U: $FIN_U\n";
	if ( open( FIN_U ) ) {
		while ( $line = <FIN_U> ) {
			$line =~ s/[\012\015]+//;
			( $key, $value ) = split( '\t', $line );
			$ENCCACHE{$key} = $value;
			$ENCCACHEENTRY[$N_ENCCACHEENTRY++] = $key;
		}
		close( FIN_U );
	}
}


########################################################################
### URLʸ󥨥󥳡ɥåν񤭽Ф
#

sub FlushENCODECACHE {
	local( $st, $ed, $i, $line, $key, $value );
	local( $umaskback );
	local( $fout );
	local( $FOUT_U );

	$ed = $N_ENCCACHEENTRY;
	$st = $ed - $MAXENCODECACHEENTRY;
	if ( $st < 0 ) {
		$st = 0;
	}
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$fout = $TMPDIR . $SLASH . $ENCODECACHENAME;
	$FOUT_U = ">$fout";
# print "Write FOUT_U: $FOUT_U\n";
	open( FOUT_U ) || die "cannot open [$fout].";
# print "st=$st ed=$ed\n";
	for ( $i=$st; $i<$ed; $i++ ) {
		$key = $ENCCACHEENTRY[$i];
		$key =~ s/\t//g;
		$value = $ENCCACHE{$key};
# print "$key\t$value\n";
		print FOUT_U "$key\t$value\n";
	}
	close( FOUT_U );
	umask( $umaskback );
}

########################################################################
### ǥå
#

sub AnalyzeDiaryIndex {
	local( $year, $month ) = @_;
	local( $i, $j, $day, $wday, $part, $topic, $fin, $line, $cmd, $dayntitle, $category, $daytime, $time );
	local( $FIN );

	$NCATEGORYWORD = 0;
	$NTITLE = 0;

	# ʬγפ
	&YMD2DAYS( $year, $month, 1 );
	$wday = $WDAY;
	for ( $day=1; $day<=$DAYS[$month]; $day++, $wday = ($wday+1) % 7 ) {
		$part = 0;
		if ( $day > 10 ) {
			$part++;
		}
		if ( $day > 20 ) {
			$part++;
		}
		$dayntitle = 0;
		$topic = '';
		$category = '';
		$time = '';
		$daytime = '';
		$fin = &MakeMasterFileName( $year, $month, $day );
		$DAYEXIST{$year,$month,$day} = 0;
		next if ( !(-e $fin) ) ;
		$DAYEXIST{$year,$month,$day} = 1;
		$cmd = $NKFCMD . ' -e ' . $fin . "|";
		$FIN = $cmd; open( FIN ) || next;
		while ( $line = <FIN> ) {
			$line =~ s/[\012\015]+//;
			if ( $line =~ s/^\@topic[ \t]+// ) {
				$topic = &Replace( $line, $year, $month, $part, $day );
				next;
			}
			if ( $line =~ s/^\@time[ \t]+// ) {
				$time = &Replace( $line, $year, $month, $part, $day );
				if ( $dayntitle > 0 ) {
					$TIME[$dayntitle-1] = $time;
				} else {
					$daytime = $time;
				}
				next;
			}
			if ( $line =~ s/^\@weather[ \t]+// ) {
				$DAYWEATHER[$day] = &Replace( $line, $year, $month, $part, $day );
				next;
			}
			if ( $line =~ s/^\@title[ \t]+// ) {
				if ( $dayntitle == 0 ) {
					$dayntitle++;
				}
				$TIME[$dayntitle] = $time;
				$CATEGORY[$dayntitle] = '';
				$TITLE[$dayntitle++] = &Replace( $line, $year, $month, $part, $day );
				next;
			}
			if ( $line =~ s/^\@category[ \t]+// ) {
				$category = &Replace( $line, $year, $month, $part, $day );
				if ( $dayntitle > 0 ) {
					$CATEGORY[$dayntitle-1] = $category;
				}
				next;
			}
		}
		close( FIN );
		if ( $dayntitle || $topic ne '' ) {
			$DAYNTITLE[$day] = $dayntitle;
			$DAYTOPIC[$day] = $topic;
			$DAYTOPICTIME[$day] = $daytime;
			$DAYLINK[$day] = sprintf( '%d %d %d %d %d %d', $year, $month, $part, $day, 0, $wday );
			for ( $i=0; $i<$dayntitle; $i++ ) {
				$DAYTITLE{$day,$i} = $TITLE[$i];
				$DAYCATEGORY{$day,$i} = $CATEGORY[$i];
				$DAYTITLETIME{$day,$i} = $TIME[$i];
			}
		}
	}
}

########################################################################
### ȥåХåե֤̾ 
#
sub MakeTrackbackLogFileName {
	local( $year, $month ) = @_;
	local( $s );

	if ( ($year==1) && ($month==1) ) {
		$s = sprintf( "${TBLOGDIR}${SLASH}latesttb.log" );
	} elsif ( ($year==1) && ($month==2) ) {
		$s = sprintf( "${TBLOGDIR}${SLASH}latestcm.log" );
	} else {
		$s = sprintf( "${TBLOGDIR}${SLASH}%04d${SLASH}%02d.log", $year+0, $month+0 );
	}
	return ($s);
}

########################################################################
### ȥåХåȥե֤̾ 
#
sub MakeTrackbackCountLogFileName {
	local( $year, $month ) = @_;
	local( $s );

	$s = sprintf( "${TBLOGDIR}${SLASH}%04d${SLASH}%02dc.log", $year+0, $month+0 );
	return ($s);
}

########################################################################
### HTML󥰻˾㳲Ȥʤʸ
#
sub HTMLCleaning {
	local( $s ) = @_;

	$s =~ s/</&lt;/g;
	$s =~ s/>/&gt;/g;
	return ($s);
}

########################################################################
### ȥåХå/ȥեɤ߹
#
sub GetTrackbackLog {
	local( $year, $month ) = @_;
	local( $s );
	local( $fin );
	local( $umaskback );
	local( $cmd );
	local( $line );
	local( @l );
	local( @expr );
	local( $s );
	local( $s2 );
	local( $n );
	local( $variable, $value );
	local( @param );

	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT_U = ">$TMPDIR/%tbutf8in.txt"; open( FOUT_U );

	$fin = &MakeTrackbackLogFileName( $year, $month );
	open( FIN, $fin );
	while ( $line = <FIN> ) {
		$line =~ s/[\015\012]//g;
		next if ( $line eq "" );
		next if ( $line =~ "^#" );
		undef( %param );
		@l = split( " ", $line );
		@expr = split( '&', $l[1] );
		foreach $s (@expr) {
			( $variable, $value ) = split( '=', $s );
			$value =~ tr/+/ /;
			$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
			$value =~ s/(\x0d|\x0a)+//eg;
			$param{$variable} = $value;
		}
		if (
		  ($param{'title'} ne "" ) &&
		  ($param{'excerpt'} ne "" ) &&
		  ($param{'url'} ne "" ) &&
		  ($param{'blog_name'} ne "" ) 
		) {
			print FOUT_U $l[0] . " \n";
			print FOUT_U $param{'title'} . " \n";
			print FOUT_U $param{'excerpt'} . " \n";
			print FOUT_U $param{'url'} . " \n";
			print FOUT_U $param{'blog_name'} . " \n";
			print FOUT_U $l[3] . " " . $l[4]  . " \n";
		}
		elsif (
		  ($param{'GNSname'} ne "" ) &&
		  ($param{'GNScomment'} ne "" ) 
		) {
			print FOUT_U $l[0] . " \n";
			$s = $param{'GNSname'} . "-++-" . $param{'GNScomment'};
			&jcode'convert( *s, "jis" );
			$s2 = $s;
			$s =~ s:\-\+\+\-.*$::;
			$s2 =~ s:^.*\-\+\+\-::;
			print FOUT_U $s . " \n";
			print FOUT_U $s2 . " \n";
			print FOUT_U "COMMENT \n";
			print FOUT_U "COMMENT \n";
			print FOUT_U $l[3] . " " . $l[4]  . " \n";
		}
	}

	close( FIN );
	umask( $umaskback );
	close( FOUT_U );
	$cmd = "$NKFCMD --euc $TMPDIR/%tbutf8in.txt>$TMPDIR/%tbeucout.txt";
	system( $cmd );
	$FIN_U = "$TMPDIR/%tbeucout.txt"; open( FIN_U );
	$n = $TB_LOG_N;
	while (!0) {
		$line = <FIN_U>;
		chomp( $line ); chop( $line );
		last if ( $line eq "" );
		$TB_LOG_YEAR[$n]     = substr( $line, 0, 4 )+0;
		$TB_LOG_MONTH[$n]    = substr( $line, 4, 2 )+0;
		$TB_LOG_DAY[$n]      = substr( $line, 6, 2 )+0;
		$TB_LOG_TITLENO[$n]  = substr( $line, 8, 2 )+0;
		$line = <FIN_U>;
		chomp( $line ); chop( $line );
		$TB_LOG_TITLE[$n]    = &HTMLCleaning( $line );
		$line = <FIN_U>;
		chomp( $line ); chop( $line );
		$TB_LOG_EXCERPT[$n]  = &HTMLCleaning( $line );
		$line = <FIN_U>;
		chomp( $line ); chop( $line );
		$TB_LOG_FROM[$n]     = &HTMLCleaning( $line );
		$line = <FIN_U>;
		chomp( $line ); chop( $line );
		$TB_LOG_BLOGNAME[$n] = &HTMLCleaning( $line );
		$TB_LOG_SORTKEY[$n]  = $TB_LOG_DAY[$n]*1000+$TB_LOG_TITLENO[$n]*10;
		if ( $TB_LOG_FROM[$n] eq "COMMENT" ) {
			$TB_LOG_SORTKEY[$n] += 0;
		} else {
			$TB_LOG_SORTKEY[$n] += 1;
		}
		$line = <FIN_U>;
		chomp( $line ); chop( $line );
		$TB_LOG_DATE[$n] = $line;
		$TB_LOG_ORDER[$n]    = $n;
		$n++;
	}
	$TB_LOG_N = $n;
	close( FIN_U );
}

########################################################################
### ȥåХå/ȥȥ񤭹
#
sub PutTrackbackCountLog {
	local( $year, $month ) = @_;
	local( $fout );
	local( $i );
	local( $s );
	local( $umaskback );

	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );

	$fout = &MakeTrackbackCountLogFileName( $year, $month );
	open( FOUT_TBC, ">$fout" );
	foreach $i ( sort (keys %TB_LOG_COUNT) ) {
		$s = $i;
		$s =~ s/\034/,/g;
		print FOUT_TBC "$s $TB_LOG_COUNT{$i}\n";
	}
	close( FOUT_TBC );
	umask( $umaskback );
}

########################################################################
### LatestɽѤSORTKEY
#
sub MakeSortKeyLatest {
	local( $i );

	for ( $i=0; $i<$TB_LOG_N; $i++ ) {
		$TB_LOG_SORTKEY[$i] = $TB_LOG_DATE[$i];
	}
}

########################################################################
### ȥåХåե򥽡Ȥ
#
sub SortTrackbackLog {
	local( $i, $j );
	local( $a );

	for ( $i=1; $i<$TB_LOG_N; $i++ ) {
		for ( $j=$i; $j>=1; $j-- ) {
			if ( $TB_LOG_SORTKEY[$TB_LOG_ORDER[$j]] lt $TB_LOG_SORTKEY[$TB_LOG_ORDER[$j-1]] ) {
				$a = $TB_LOG_ORDER[$j];
				$TB_LOG_ORDER[$j] = $TB_LOG_ORDER[$j-1];
				$TB_LOG_ORDER[$j-1] = $a;
			}
		}
	}
}

########################################################################
### ȥåХåΥǥå
#
sub MakeIndexTrackbackLog {
	local( $i, $j );
	local( $a );
	local( $n );
	local( $year_last, $month_last, $day_last );

	return if ( $TB_LOG_N == 0 );
	$year_last = -1;
	$month_last = -1;
	$day_last = -1;
	
	for ( $i=0; $i<$TB_LOG_N; $i++ ) {
		$n = $TB_LOG_ORDER[$i];
# print "$i $n $TB_LOG_SORTKEY[$n], $TB_LOG_TITLE[$n], $TB_LOG_FROM[$n], $TB_LOG_BLOGNAME[$n], $TB_LOG_EXCERPT[$n], $TB_LOG_DATE[$n]\n";
		if ( ($year_last != $TB_LOG_YEAR[$n]) ||
		     ($month_last != $TB_LOG_MONTH[$n]) ||
		     ($day_last != $TB_LOG_DAY[$n])
		) {
			$year_last = $TB_LOG_YEAR[$n];
			$month_last = $TB_LOG_MONTH[$n];
			$day_last = $TB_LOG_DAY[$n];
			$TB_LOG_INDEX{$year_last,$month_last,$day_last} = $i;
		}
		$TB_LOG_COUNT{$TB_LOG_YEAR[$n],$TB_LOG_MONTH[$n],$TB_LOG_DAY[$n],$TB_LOG_TITLENO[$n]}++;
	}
}

########################################################################
### եɽ 
#
sub PrintTrackbackDate {
	local( $FOUT, $year, $month, $day, $wday, $part ) = @_;
	local( $s );
	local( $tbmode ) = 2;

	$s = sprintf(
	  "<A NAME=\"$ANCHOR%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d\">" .
	  "<SPAN class=\"yymmdd\">%04d/%02d/%02d</SPAN></A> " .
	  "<SPAN class=\"dayweek\">(%s)</SPAN> " .
	  "<SPAN class=\"dayweather\">%s</SPAN> " .
	  "<SPAN class=\"daytopic\">%s</SPAN>" .
	  "",
	  $day, $year, $month, $PARTS[$PART], $day, $year, $month, $day,
	  $WDAYS[$wday], $DAYWEATHER[$day], $DAYTOPIC[$day]
	);

	$s = &SPrintDiaryDate_Config2( $s, $year, $month, $day, $wday, $PART, $DAYWEATHER[$day], $DAYTOPIC[$day], $DAYTOPICTIME[$day], $tbmode );
	$s =~ s/[ ]+$//;
	print $FOUT "<DIV class=\"daybox\">\n";
	print $FOUT "<DIV class=\"datebox\"><H3 class=\"date\">$s</H3></DIV>\n";
}

########################################################################
### ȥ륿ɽ 
#
sub SPrintTrackbackTitle {
	local( $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time ) = @_;
	local( $s );
	local( $catprint );
	local( $tbmode ) = 2;

	if ( $category eq '' ) {
		$s = sprintf(
		  "<DIV class=\"titlebox\"><H4 class=\"title\">" .
		  "<A NAME=\"$ANCHOR%02d%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d%02d\">" .
		  "<SPAN class=\"titlemark\">%s</SPAN>" .
		  "<SPAN class=\"titlestr\">%s</SPAN>" .
		  "</A></H4>" .
		  "<DL class=\"dl\"><DD class=\"dd\">".
		  "",
		  $day, $ntitle,
		  $year, $month, $PARTS[$part], $day,
		  $ntitle, $TITLEMARK, $title
		);
	} else {
		$catprint = &MakeCategoryLinkStrings( $year, $category );
		$s = sprintf(
		  "<DIV class=\"titlebox\"><H4 class=\"title\">" .
		  "<A NAME=\"$ANCHOR%02d%02d\" HREF=\"%04d%02d%s.html#$ANCHOR%02d%02d\">" .
		  "<SPAN class=\"titlemark\">%s</SPAN>" .
		  "<SPAN class=\"titlestr\">%s</SPAN>" .
		  "</A>" .
		  "<SPAN class=\"category\"> (%s)</SPAN>" .
		  "</H4>" .
		  "<DL class=\"dl\"><DD class=\"dd\">".
		  "",
		  $day, $ntitle,
		  $year, $month, $PARTS[$part], $day,
		  $ntitle, $TITLEMARK, $title, $catprint
		);
	}

	return ( &SPrintDiaryTitle_Config2( $s, $year, $month, $day, $wday, $part, $ntitle, $title, $category, $time, $tbmode ) );
}

########################################################################
### ȥåХåϤ
#
sub PrintTrackbackLog {
	local( $FOUT, $year, $month, $day ) = @_;
	local( $part, $istoday );
	local( $wday, $i, $s );
	local( $titleno );
	local( $ntitle );
	local( $tbno );
	local( $cmno );

	return if ( !defined($TB_LOG_INDEX{$year,$month,$day}) );

	&YMD2DAYS( $year, $month, $day );
	$wday = $WDAY;
	&GetDiaryPart( $year, $month, $day );
	$part = $PART;

	&PrintTrackbackDate( $FOUT, $year, $month, $day, $wday, $part );

	$ntitle = 0;
	$titleno = -1;
	$tbno = 0;
	$cmno = 0;
	for ( $i=$TB_LOG_INDEX{$year,$month,$day}; $i<$TB_LOG_N; $i++ ) {
		$n = $TB_LOG_ORDER[$i];
		next if ( $TB_LOG_YEAR[$n] != $year );
		next if ( $TB_LOG_MONTH[$n] != $month );
		next if ( $TB_LOG_DAY[$n] != $day );
		if ( $titleno != $TB_LOG_TITLENO[$n] ) {
			$ntitle++;
			if ( $ntitle > 1 ) {
				$s = &SPrintDiaryTitleClose(
				  $year, $month, $day, $day, $part, $titleno, $DAYTITLE{$day,$titleno}, $DAYCATEGORY{$day,$titleno}, $DAYTIME{$day,$titleno}
				);
				print $FOUT "$s\n";
			}
			$titleno = $TB_LOG_TITLENO[$n];
			$s = &SPrintTrackbackTitle(
			  $year, $month, $day, $day, $part, $titleno, $DAYTITLE{$day,$titleno}, $DAYCATEGORY{$day,$titleno}, $DAYTIME{$day,$titleno}
			);
			print $FOUT "$s\n";
			$tbno = 0;
			$cmno = 0;
		}
		if ( $TB_LOG_FROM[$n] ne "COMMENT" ) {
			$tbno++;
			if ( $tbno == 1 ) {
				$s = sprintf( "<DIV class=\"tbheader\"><B><A NAME=\"%02d%02dtb\" HREF=\"#%02d%02dtb\">[Trackback]</A></B></DIV>\n",
				              $day, $titleno,
				              $day, $titleno
				);
				print $FOUT "$s\n";
			}
			$s = sprintf( "<DL class=\"tbline\"><DT><A NAME=\"%02d%02dtb%d\" HREF=\"#%02d%02dtb%d\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"tbtitle\"><A HREF=\"%s\">%s</A></SPAN></DT>" .
			              "<DD><SPAN class=\"tbexcerpt\">%s</SPAN> " .
			              "<SPAN class=\"tbfrom\">(%s)</SPAN></DD></DL>\n",
			              $day, $titleno, $tbno,
			              $day, $titleno, $tbno,
			              $TB_LOG_DATE[$n],
			              $TB_LOG_FROM[$n], $TB_LOG_TITLE[$n], $TB_LOG_EXCERPT[$n],
			              $TB_LOG_BLOGNAME[$n]
			);
			print $FOUT "$s\n";
		} else {
			$cmno++;
			if ( $cmno == 1 ) {
				$s = sprintf( "<DIV class=\"cmheader\"><B><A NAME=\"%02d%02dcm\" HREF=\"#%02d%02dcm\">[Comment]</A></B></DIV>\n",
				              $day, $titleno,
				              $day, $titleno
				);
				print $FOUT "$s\n";
			}
			$s = sprintf( "<DIV class=\"cmline\"><A NAME=\"%02d%02dcm%d\" HREF=\"#%02d%02dcm%d\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"cmcomment\">%s</SPAN> " .
			              "<SPAN class=\"cmname\">(%s)</SPAN></DIV>\n",
			              $day, $titleno, $cmno,
			              $day, $titleno, $cmno,
			              $TB_LOG_DATE[$n],
			              $TB_LOG_EXCERPT[$n], $TB_LOG_TITLE[$n]
			);
			print $FOUT "$s\n";
		}
	}

	if ( $ntitle >= 1 ) {
		$s = &SPrintDiaryTitleClose(
		  $year, $month, $day, $day, $part, $titleno, $DAYTITLE{$day,$titleno}, $DAYCATEGORY{$day,$titleno}, $DAYTIME{$day,$titleno}
		);
		print $FOUT "$s\n";
	}
	print $FOUT "</DIV><!-- daybox -->\n";

}

########################################################################
### ȥåХåѥӥ塼 
#
sub BindTrackbackView {
	local( $year, $month, $day, $titleno ) = @_;
	local( $enddate, $part, $i, $fout, $fout2, $cmd, $fin, $line, $needinterval );
	local( $umaskback );
	local( $FOUT );

	$needinterval = 0;

	$fout = $TMPDIR . $SLASH . '%tmptb.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $TRACKBACKHEADERNAME, $year, $month, 0 );
	&PrintStart( *FOUT );

	$TB_LOG_N = 0;
	&GetTrackbackLog( $year, $month );
	&SortTrackbackLog();
	&MakeIndexTrackbackLog();
	&AnalyzeDiaryIndex( $year, $month );
	&PutTrackbackCountLog( $year, $month );

	&Setup_DAYS( $year );
	for ( $i=1; $i<=$DAYS[$month]; $i++ ) {
		if ( !defined($TB_LOG_INDEX{$year,$month,$i}) ) {
			if ( !$PRINTNOEXISTDAY ) {
				next;
			}
		}
		if ( $needinterval ) {
			&PrintInterval( *FOUT );
		}
		&PrintTrackbackLog( *FOUT, $year, $month, $i );
		$needinterval = !0;
	}
	&PrintTerminate( *FOUT );
	&CatFile( *FOUT, $KEEPDIR . $SLASH . $TRACKBACKFOOTERNAME, $year, $month, 0 );
	close( FOUT );

	umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$fout2 = sprintf( $PUTDIR . $SLASH . '%04d%02d%st.html', $year, $month );
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
	system( $cmd );
	umask( $umaskback );

}

########################################################################
### ȥåХå(latest)ѥӥ塼 
#
sub BindTrackbackViewLatest {
	local( $year, $month, $day, $titleno );
	local( $tb_s, $tb_e, $i, $n, $s, $cm );
	local( $umaskback );
	local( $FOUT );

	$needinterval = 0;

	$fout = $TMPDIR . $SLASH . '%tmptb.out';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	$FOUT = ">$fout"; open( FOUT ) || die "cannot open [$fout].";

	$TB_LOG_N = 0;
	&GetTrackbackLog( 1, 1 );  # latesttb
	&GetTrackbackLog( 1, 2 );  # latestcm
	&MakeSortKeyLatest();
	&SortTrackbackLog();

	$tb_s = $TB_LOG_N-1;
	$tb_e = $tb_s - $VIEWLATESTTRACKBACKCOUNT+1;
	$tb_e = 0 if ( $tb_e < 0 );
	for ( $i=$tb_s; $i>=$tb_e; $i-- ) {
		$n = $TB_LOG_ORDER[$i];

		$year = $TB_LOG_YEAR[$n];
		$month = $TB_LOG_MONTH[$n];
		$day = $TB_LOG_DAY[$n];
		$titleno = $TB_LOG_TITLENO[$n];
		if ( $TB_LOG_FROM[$n] ne "COMMENT" ) {
			$s = sprintf( "<DIV class=\"tblline\"><A HREF=\"%s%04d%02dt.html#%02d%02dtb\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"tbtitle\">[trackback] %s</SPAN>" .
			              "<SPAN class=\"tbfrom\">(%s)</SPAN></DIV>\n",
			              $TRACKBACKBASEURL, $year, $month, $day, $titleno,
			              $TB_LOG_DATE[$n],
			              $TB_LOG_TITLE[$n],
			              $TB_LOG_BLOGNAME[$n]
			);
			print FOUT "$s\n";
		} else {
			$cm = $TB_LOG_EXCERPT[$n];
			if ( $cm =~ s:^(([\x00-\x7f]|[\x80-\xff][\x80-\xff]){32}).*$:\1: ) {
				$cm .= "...";
			}
			$s = sprintf( "<DIV class=\"cmline\"><A HREF=\"%s%04d%02dt.html#%02d%02dcm\"><SPAN class=\"tbdate\">%s</SPAN></A>\n" .
			              "<SPAN class=\"cmcomment\">%s</SPAN> " .
			              "<SPAN class=\"cmname\">(%s)</SPAN></DIV>\n",
			              $TRACKBACKBASEURL, $year, $month, $day, $titleno,
			              $TB_LOG_DATE[$n],
			              $cm,
			              $TB_LOG_TITLE[$n]
			);
			print FOUT "$s\n";
		}
		
	}
	close( FOUT );

	umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$fout2 = sprintf( $PUTDIR . $SLASH . 'tbcmlatest.html' );
	$cmd = $NKFCMD . ' ' . $NKFCODE . ' ' . $fout . '>' . $fout2;
	system( $cmd );
	umask( $umaskback );

}

1;
# [EOF]
